#!/usr/bin/env python
# coding: utf-8

# In[16]:

# In[17]:


import pandas as pd
import matplotlib.pyplot as plt
import sys
import windrose
import numpy as np
import openpyxl
from openpyxl.workbook import Workbook
from openpyxl import load_workbook
import math


# In[10]:


directorio=r'D:\TEC\2021 Segundo Semestre\Asistencia\Semana 3 Código de Python' #colocar el directorio con los archivos aqui
nombre=('F2103') #colocar aqui el nombre sin extension del archivo a procesar
archivo=(directorio +'\\'+ nombre +'.csv')


# ATENCION: Asegúrese que el directorio de la carpeta donde va a guardar los archivos sea correcto, así como el nombre del archivo, esos son los únicos dos cambios que debe hacer como usuario. Cuando eso esté listo, solo tiene que apretar el botón para correr todo el código (la doble flechita que está debajo de la barra de herramientas, a la par del tipo de celda)

# In[11]:


df = pd.read_csv(archivo, sep=';', engine='python')
df.replace(to_replace='NNE', value='142,5', inplace=True)
df.replace(to_replace='ENE', value='187,5', inplace=True)
df.replace(to_replace='ESE', value='232,5', inplace=True)
df.replace(to_replace='SSW', value='322,5', inplace=True)
df.replace(to_replace='SSE', value='277,5', inplace=True) 
df.replace(to_replace='WNW', value='52,5', inplace=True)
df.replace(to_replace='WSW', value='7,5', inplace=True)
df.replace(to_replace='NNW', value='97,5', inplace=True)
df.replace(to_replace='SW', value='345', inplace=True)
df.replace(to_replace='NE', value='165', inplace=True)
df.replace(to_replace='NW', value='75', inplace=True)
df.replace(to_replace='SE', value='255', inplace=True)
df.replace(to_replace='E', value='210', inplace=True)
df.replace(to_replace='S', value='300', inplace=True)
df.replace(to_replace='W', value='30', inplace=True)
df.replace(to_replace='N', value='120', inplace=True)

df.rename(columns={'Wind Speed TX1 (m/s)':'Velocidad a 10 m (m/s)', 'Wind Speed TX2 (m/s)':'Velocidad a 14 m (m/s)', 'Dominant Wind Dir TX1':'Direccion del viento a 10 m (°)', 'Dominant Wind Dir TX2':'Direccion del viento a 14 m (°)'}, inplace=True)


df['Outside Humidity TX1 (%)']=df['Outside Humidity TX1 (%)'].astype(str)
df=df.stack().str.replace(',','.').unstack()

df['Velocidad a 10 m (m/s)']=df['Velocidad a 10 m (m/s)'].astype(float)
df['Velocidad a 14 m (m/s)']=df['Velocidad a 14 m (m/s)'].astype(float)
df['Direccion del viento a 10 m (°)']=df['Direccion del viento a 10 m (°)'].astype(float)
df['Direccion del viento a 14 m (°)']=df['Direccion del viento a 14 m (°)'].astype(float)
df


# En esta siguiente parte es donde se va a generar la rosa de los vientos

# In[13]:


ax10= windrose.WindroseAxes.from_ax()
ax10.bar(df['Direccion del viento a 10 m (°)'], df['Velocidad a 10 m (m/s)'], opening=0.8, normed=True, edgecolor='white' )
ax10.set_xticklabels(['E', 'NE', 'N', 'NW',  'W', 'SW', 'S', 'SE'])
ax10.set_theta_zero_location('E')
ax10.set_legend()
ax10.set_yticklabels(labels=ax10.get_yticklabels(),fontsize=12)

plt.title('10 m', fontdict={'fontsize':15})

plt.savefig(nombre + ' rosa_10m.jpg')

ax14= windrose.WindroseAxes.from_ax()
ax14.set_theta_zero_location('E')
ax14.bar(df['Direccion del viento a 14 m (°)'], df['Velocidad a 14 m (m/s)'], opening=0.8, normed=True, edgecolor='white' )
ax14.set_xticklabels(['E', 'NE', 'N', 'NW',  'W', 'SW', 'S', 'SE'])
ax14.set_legend()
ax14.set_yticklabels(labels=ax14.get_yticklabels(),fontsize=12)

plt.title('14 m', fontdict={'fontsize':15})
plt.savefig(nombre + ' rosa_14m')


# Aqui ahora se va a generar el histograma de velocidad de viento combinado

# In[14]:


plt.clf()
dfa=df.copy(deep=True)

dfa['Velocidad a 10 m (m/s)']=dfa['Velocidad a 10 m (m/s)'].apply(np.ceil)
dfa['Velocidad a 14 m (m/s)']=dfa['Velocidad a 14 m (m/s)'].apply(np.ceil)
n10,x10,_=plt.hist(dfa['Velocidad a 10 m (m/s)'], bins=np.arange(10)-0.5,weights=np.zeros_like(dfa['Velocidad a 10 m (m/s)']) + 100. / dfa['Velocidad a 10 m (m/s)'].size,
         edgecolor='black', linewidth=0.6)
plt.xlabel('Velocidad a 10 m (m/s)')
plt.xticks([0,1,2,3,4,5,6,7,8,9,10])
plt.ylabel('Frecuencia (%)')
plt.savefig(nombre + ' Histograma1.jpg') 
plt.show()

n14,x14,_=plt.hist(dfa['Velocidad a 14 m (m/s)'], bins=np.arange(10)-0.5,weights=np.zeros_like(dfa['Velocidad a 14 m (m/s)']) + 100. / dfa['Velocidad a 14 m (m/s)'].size,
         edgecolor='black', color = 'orange', linewidth=0.6)
plt.xlabel('Velocidad a 14 m (m/s)')
plt.xticks([0,1,2,3,4,5,6,7,8,9,10])
plt.ylabel('Frecuencia (%)')
plt.savefig(nombre + ' Histograma2.jpg') 
plt.show()


# Aqui ahora se van a generar los dos histogramas "clasicos" de velocidad de viento individuales.

# In[15]:


plt.xticks([0,1,2,3,4,5,6,7,8,9,10])
bin_centers10 = 0.5*(x10[1:]+x10[:-1])
bin_centers14 = 0.5*(x14[1:]+x14[:-1])
plt.plot(bin_centers10,n10, label='10 m')
plt.plot(bin_centers14,n14, label='14 m')
plt.title('Velocidad del viento en el CIF, '+nombre[3:]+'/'+nombre[1:3])
plt.legend(loc='upper right', title='Altura')
plt.xlabel('Velocidad del viento (m/s)')
plt.ylabel('Frecuencia relativa (%)')
plt.grid()
plt.savefig(nombre + ' Histograma3.jpg')  
plt.show()


# In[7]:



###Aquí se devuelve a str para volver a poner las , y guardar el archivo
df['Velocidad a 10 m (m/s)']=df['Velocidad a 10 m (m/s)'].astype(str)
df['Velocidad a 14 m (m/s)']=df['Velocidad a 14 m (m/s)'].astype(str)
df['Direccion del viento a 10 m (°)']=df['Direccion del viento a 10 m (°)'].astype(str)
df['Direccion del viento a 14 m (°)']=df['Direccion del viento a 14 m (°)'].astype(str)

df=df.stack().str.replace('.',',').unstack()
df.to_excel(directorio +'\\'+ nombre +'Excel.xlsx')

